"use strict";

window.$stillbe       = (window.$stillbe       || {});
window.$stillbe.func  = (window.$stillbe.func  || {});
window.$stillbe.admin = (window.$stillbe.admin || {});

window.$stillbe.admin.__ = function($id){
	if(!("translate" in window.$stillbe.admin)){
		return $id;
	}
	return window.$stillbe.admin.translate[$id] || $id;
};

// Ajax Request Wrapper Function
window.$stillbe.func.ajaxRequest = function($method = "POST", $url = null, $data = {}, $callback = null){
	if(!$url || typeof $callback !== "function"){
		return false;
	}
	const xhr = new XMLHttpRequest();
	const err = function(){
		alert(__("An error has occurred.... Please try again."));
		$callback.call(null, { ok: false, body: xhr.responseText });
	};
	xhr.timeout   = 30 * 1000;
	xhr.onerror   = err;
	xhr.ontimeout = err;
	xhr.onload    = function(){
		let result = false;
		try{
			result = JSON.parse(xhr.responseText);
		} catch{}
		console.log(result);
		$callback.call(null, { ok: true, json: result, body: xhr.responseText });
	};
	xhr.ontimeout = $callback;
	xhr.onerror   = $callback;
	// Append Data & Request
	if($method.toUpperCase() !== "GET"){
		const dat = new FormData();
		$data = $data || {};
		for(let key in $data){
			dat.append(key, $data[key]);
		}
		xhr.open(String($method).toUpperCase(), $url, true);
		xhr.send(dat);
	} else{
		const dat = [];
		$data = $data || {};
		for(let key in $data){
			dat.push(encodeURIComponent(key) + "=" + encodeURIComponent($data[key]));
		}
		xhr.open("GET", $url + dat.join("&").replace(/%20/g, "+"), true);
		xhr.send();
	}
};


// Get Images IDs
window.addEventListener("DOMContentLoaded", function(){
	const button = document.getElementById("get_attachment_id");
	const list   = document.querySelector("#ids_list .scroll-wrapper");
	const url    = window.$stillbe.admin.ajaxUrl;
	const nonce  = window.$stillbe.admin.nonce;
	const __     = window.$stillbe.admin.__;
	if(!button || !list || !url || !nonce){
		return null;
	}
	let runing = false;
	const data = {
		action: "sb_iqc_get_attachment_ids",
		_nonce: nonce.getIds,
	};
	button.onclick = function(){
		if(runing){
			return null;
		}
		button.disabled = true;
		runing = true;
		window.$stillbe.func.ajaxRequest("POST", url, data, function($response){
			if(!$response || !$response.ok){
				if($response){
					alert(__("An error has occurred.... Please try again."));
				}
				runing = false;
				return false;
			}
			const result = $response.json || {};
			const frag   = new DocumentFragment();
			const ul     = frag.appendChild(document.createElement("ul"));
			(result.ids || []).forEach(function($id){
				const li = ul.appendChild(document.createElement("li"));
				li.innerText = $id;
			});
			while(list.firstChild){list.firstChild.remove();}
			list.appendChild(frag);
			window.$stillbe.admin.image = {ids: (result.ids || [])};
			if(!document.getElementById("count_ids")){
				button.parentNode.insertBefore(document.createElement("div"), button.nextElementSibling).id = "count_ids";
			}
			document.getElementById("count_ids").innerText = window.$stillbe.admin.image.ids.length + " " + __("Files");
			button.disabled = false;
			runing = false;
		});
	};
}, false);


// Regenerate Images
window.addEventListener("DOMContentLoaded", function(){
	const button = document.getElementById("regenerate_images");
	const url    = window.$stillbe.admin.ajaxUrl;
	const nonce  = window.$stillbe.admin.nonce;
	const __     = window.$stillbe.admin.__;
	if(!button || !url || !nonce){
		return null;
	}
	const progressBar = document.getElementsByClassName("progress-bar");
	const progress    = document.getElementsByClassName("progress");
	let runing = false;
	const data = {
		action: "sb_iqc_regenerate_images",
		_nonce: nonce.reGenImg,
	};
	const doReGen = function($i){
		if(!window.$stillbe.admin.image.ids[$i]){
			button.disabled = false;
			runing = false;
			return null;
		}
		data.attachment_id = window.$stillbe.admin.image.ids[$i];
		window.$stillbe.func.ajaxRequest("POST", url, data, function($response){
			if(!$response || !$response.ok){
				if($response){
					alert(__("An error has occurred.... Please try again."));
				}
				button.disabled = false;
				runing = false;
				return false;
			}
			const result = $response.json || {};
			if(result.nonce){
				data._nonce = result.nonce;
			}
			const next = result.again ? $i : ($i + 1);
			const prog = ~~(next / window.$stillbe.admin.image.ids.length * 100) + "%";
			progress[0].style.width = prog;
			progress[0].dataset.progress = prog;
			if(window.$stillbe.admin.image.ids[next]){
				setTimeout(doReGen.bind(null, next), 1000);
			//	doReGen(next);
			} else{
				alert(__("All the regeneration is done!"));
				button.disabled = false;
				runing = false;
			}
		});
	};
	button.onclick = function(){
		if(runing){
			return null;
		}
		if(!("image" in window.$stillbe.admin)){
			document.getElementById("get_attachment_id").click();
			return null;
		}
		button.disabled = true;
		runing = true;
		// Progress Bar
		if(progressBar.length < 1){
			button.parentNode.insertBefore(document.createElement("div"), button)
				.classList.add("progress-bar");
			progressBar[0].appendChild(document.createElement("div"))
				.classList.add("progress");
		}
		progress[0].style.width = "0%";
		// Start!!
		doReGen(0);
	};
}, false);

