<?php

// Do not allow direct access to the file.
if( ! defined( 'ABSPATH' ) ) {
	exit;
}




// Reset Settings
add_action( 'wp_ajax_sb_iqc_reset_settings', function() {

	// Nonce Check
	if( ! wp_verify_nonce( $_POST['_nonce'], 'sb-iqc-reset-settings' ) ) {
		exit( json_encode( array(
			'ok'      => false,
			'message' => __( 'The page has expired. Please reload the page.', 'stillbedomain' ),
		) ) );
	}

	// Delete Setting
	$result = delete_option( StillBE_Img_Quality_Ctrl_Setting::SETTING_NAME );

	// Get User Data
	exit( json_encode( array(
		'ok'      => $result,
		'message' => $result ? __( 'The settings have been reset!!', 'stillbedomain' ) :
		                       __( 'Reset failed or it is not set.', 'stillbedomain' ) ,
		'deleted' => $result ? ( 'Option Name: '. StillBE_Img_Quality_Ctrl_Setting::SETTING_NAME ) : 'null',
	) ) );

} );





// END

?>